<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'DibGradientNumber',
  props: {
    number: {
      type: Number,
      required: true,
      default: 0,
    },
    label: {
      type: String,
      required: false,
      default: null,
    },
    text: {
      type: String,
      required: false,
      default: null,
    },
    startValue: {
      type: Number,
      required: false,
      default: 0,
    },
    speed: {
      type: Number,
      required: false,
      default: 1000,
    },
    textVariant: {
      type: String,
      required: false,
      default: 'heading1',
    },
    fontSize: {
      type: Number,
      required: false,
      default: null,
    },
    threshold: {
      type: Number,
      required: false,
      default: 1,
    },
  },
  data() {
    return {
      observer: null,
      updateCountTimeOutId: null,
      incrementTimeOutId: null,
      disableAnimations: false,
      setStartValue: this.startValue,
    };
  },
  mounted() {
    const mediaQuery = window.matchMedia('(prefers-reduced-motion: reduce)');
    if (!mediaQuery.matches) {
      this.observer = new IntersectionObserver(this.animationHandler, {
        rootMargin: '0px',
        threshold: this.threshold,
      });
      const children = this.$refs.number as HTMLElement;
      this.observer.observe(children);
    } else {
      this.setStartValue = this.number;
    }
  },
  beforeDestroy() {
    this.observer.disconnect();
  },
  methods: {
    animationHandler(entries: any, observer) {
      entries.forEach((entry: any) => {
        const element = entry.target;

        if (entry.isIntersecting) {
          observer.unobserve(element);
          this.updateCount(element);
        }
      });
    },
    updateCount(element) {
      const endValue = this.number;
      const rangeValue = endValue - this.startValue;
      const increment = endValue > this.startValue ? 1 : -1;
      const stepTime = Math.abs(Math.floor(this.speed / Math.abs(rangeValue))); // Ensure non-zero division
      let currentValue = this.startValue;

      const timer = setInterval(() => {
        if (
          (increment === 1 && currentValue >= endValue) ||
          (increment === -1 && currentValue <= endValue)
        ) {
          // If we've reached the end value, stop the timer and set currentValue to endValue
          clearInterval(timer);
          currentValue = endValue;
        } else {
          currentValue += increment; // Increment currentValue if we haven't reached the end value yet
        }

        const formattedValue =
          currentValue % 1 !== 0
            ? currentValue.toFixed(1)
            : currentValue.toString(); // Display one decimal place only if necessary
        element.innerHTML = formattedValue;
      }, stepTime);
    },
  },
});
</script>

<template>
  <div class="gradient-number">
    <SlpTypography
      :variant="fontSize ? null : textVariant ?? 'heading1'"
      tag="p"
      class="number"
      :style="fontSize ? { 'font-size': fontSize + 'px' } : {}"
    >
      <span ref="number" :data-target="number" class="animated-number">{{
        setStartValue
      }}</span
      ><span class="percent">%</span>
    </SlpTypography>
  </div>
</template>

<style lang="scss" scoped>
.gradient-number {
  display: block;
  margin: 24px 0;

  .text {
    display: block;
  }
  .number {
    font-weight: 800;
  }
  .animated-number,
  .percent {
    -webkit-text-fill-color: transparent;
    background: linear-gradient(
      93.78deg,
      rgba(227, 153, 93, 0.7) 8.53%,
      rgba(203, 146, 150, 0.7) 14.9%,
      rgba(127, 72, 214, 0.7) 95.91%
    );

    background-clip: text;
    -webkit-background-clip: text;
  }
}
</style>
